// Bambino
// TAB FILE > initPM20.h

//Initialise various things in Setup()

  Serial.begin(9600);       // to communicate with Serial Monitor   
  Serial.print(thisrobot);  // so we know which robot the program is for
  Serial.print(" ");
  Serial.println(thisprog); // so we know which program is running

  if (255==EEPROM.read(Ef_walking)) {initialiseEEPROM();}      // in case it is not initialised
  
  toggle_f_walking();       // toggles on reset
  if (f_walking) {Serial.println(" walking");} else {Serial.println(" stopped");}
  
  debug =1;   // debug printing, =0 turn off,  =1 turn on
  
  rollC =EEPROM.read(ErollC);     // initialise rollC from EEPROM, stand upright value
  paceC =EEPROM.read(EpaceC);     // initialise paceC from EEPROM, feet together value
  rollby =EEPROM.read(Erollby);   // set to EEPROM value
  paceby =EEPROM.read(Epaceby);   // set to EEPROM value

  pinMode(servoRollPin, OUTPUT);    // sets the digital pin as output
  pinMode(servoPacePin, OUTPUT);    // sets the digital pin as output
  digitalWrite(servoRollPin, LOW);  // initialise pin
  digitalWrite(servoPacePin, LOW);  // initialise pin
  ServosInitC();
  
  pinMode(voicePin,OUTPUT);
  pinMode(LbeardLEDpin_, OUTPUT);  
  pinMode(RbeardLEDpin_, OUTPUT);  
  pinMode(LwhiskerLEDpin_, OUTPUT);
  pinMode(RwhiskerLEDpin_, OUTPUT);
  digitalWrite(LbeardLEDpin_, HIGH);  // beard LED OFF
  digitalWrite(RbeardLEDpin_, HIGH);  // beard LED OFF
  digitalWrite(LwhiskerLEDpin_, HIGH);// whisker LED OFF
  digitalWrite(RwhiskerLEDpin_, HIGH);// whisker LED OFF    
