// Bambino
// TAB FILE > actsPM23.ino

//     ACTS - WanderSteps(steps), Wander()
//            RightStep(steps), LeftStep(steps)
//            rock(repeats), shuffle(repeats) 
//     SOUND - whee(), whoa() 

//== ACTS ===================================================
void WanderSteps(int steps)     // Wander and avoid for 'repeat' steps
{ while(steps--)
  { Wander();           // Wander and avoid
  }	
} 
//----------------------------
void Wander()           // Wander and avoid, just one step
{ readBeard();
  queryEdge();
  avoidHoles();                // if there is a hole then avoid it
  readWhiskers();
  queryObstacles();
  avoidObstacles();            // if there is an obstacle then avoid it
  objectRange =dist_HC_SR04();  
  avoidUObjects();              // if there is an object then avoid it
  forward();
  speedup();
}    
//----------------------------
void RightStep(int steps)   //turnRight for repeat steps
{ while(steps--)
  { turnRight(); }
}
//----------------------------
void LeftStep(int steps)   //turnLeft for repeat steps
{ while(steps--)
  { turnLeft(); }
}
//----------------------------
void rock(int steps)
{ while(steps--)
  { rollRight(); rollLeft(); }
}
//----------------------------
void shuffle(int steps)
{ while(steps--)  
  { paceRightForward(); paceRightBackward(); }
}
//== SOUND ==================================================
void whee()   // make rising sound
{ for (int i=500; i<5000; i+=100) 
    { beep(voicePin,i,10); }
}	
//----------------------------
void whoa()   // make falling sound
{ for (int i=5000; i>500; i-=100) 
    { beep(voicePin,i,10); }
}	
//===========================================================









